const coral = @import("coral");

pub const CheckError = error {
	CheckFailed
};

pub const Float = f32;

pub const Integer = i32;

pub const Object = u32;

pub const Primitive = enum {
	nil,
	false,
	true,
	float,
	integer,
	object,
};

pub const Ref = union (Primitive) {
	nil,
	false,
	true,
	float: Float,
	integer: Integer,
	object: Object,
};

pub const ParseError = error {
	OutOfMemory,
	BadSyntax,
};

pub const RuntimeError = CheckError || ParseError;

pub const Val = union (Primitive) {
	nil,
	false,
	true,
	float: Float,
	integer: Integer,
	object: Object,

	pub fn as_ref(self: *const Val) Ref {
		return switch (self.*) {
			.nil => .nil,
			.false => .false,
			.true => .true,
			.float => .{.float = self.float},
			.integer => .{.integer = self.integer},
			.object => .{.object = self.object},
		};
	}
};
